package ru.dbotthepony.kstarbound.defs.item.impl

import ru.dbotthepony.kommons.util.Either
import ru.dbotthepony.kstarbound.defs.item.api.IItemDefinition
import ru.dbotthepony.kstarbound.defs.item.api.ILiquidItem
import ru.dbotthepony.kstarbound.json.builder.JsonAlias
import ru.dbotthepony.kstarbound.json.builder.JsonFactory
import ru.dbotthepony.kstarbound.json.builder.JsonFlat

@JsonFactory
data class LiquidItemDefinition(
	@JsonFlat
	val parent: IItemDefinition,
	@JsonAlias("liquidId", "liquidName")
	override val liquid: Either<Int, String>,
) : IItemDefinition by parent, ILiquidItem {
	override val itemType: String
		get() = super<ILiquidItem>.itemType
}
