package ru.dbotthepony.kstarbound.defs.world.terrain

import ru.dbotthepony.kstarbound.json.builder.JsonFactory
import java.util.random.RandomGenerator

@JsonFactory
data class TerrainSelectorParameters(
	val worldWidth: Int,
	val baseHeight: Double,
	val seed: Long = 0L,
	val commonality: Double = 0.0
) {
	fun withSeed(seed: Long) = copy(seed = seed)
	fun withCommonality(commonality: Double) = copy(commonality = commonality)
	private var random: RandomGenerator? = null

	fun random(): RandomGenerator {
		return random ?: ru.dbotthepony.kstarbound.util.random.random(seed)
	}

	fun withRandom(): TerrainSelectorParameters {
		if (random == null)
			return withRandom(ru.dbotthepony.kstarbound.util.random.random(seed))

		return this
	}

	fun withRandom(randomGenerator: RandomGenerator): TerrainSelectorParameters {
		return copy().also { it.random = randomGenerator }
	}
}
