package ru.dbotthepony.kstarbound.util

import ru.dbotthepony.kommons.util.ITimeSource

class Clock : ITimeSource {
	var origin = System.nanoTime()
		private set

	var baseline = 0L
		private set

	var isPaused = false
		private set

	fun set(nanos: Long) {
		origin = System.nanoTime()
		baseline = nanos
	}

	fun pause() {
		if (!isPaused) {
			baseline += System.nanoTime() - origin
			isPaused = true
		}
	}

	fun unpause() {
		if (isPaused) {
			origin = System.nanoTime()
			isPaused = false
		}
	}

	override val nanos: Long
		get() = if (isPaused) baseline else (System.nanoTime() - origin) + baseline
}
